﻿function bdShowHide() {
	var effekt = 'blind';
	if (choo.bd.apv) {
		$('.bd-hidemech').show(effekt);
		$('.bd-hideapv').hide();
		if (choo.bd.vw) {
			$('.bd-hidevw').hide();
			$('.bd-hidevv').show(effekt);
		} else {
			$('.bd-hidevw').show(effekt);
			$('.bd-hidevv').hide();
		}
	} else {
		$('.bd-hidemech').hide();
		$('.bd-hideapv').show(effekt);
	}
	return;
}
function calcBattDrain() {
	var html = '';
	var bd = choo.bd;
	if (!bd.apv) { // mech
		bd.battcurr = bd.battu/bd.attyres;
		bd.battpow = bd.battcurr * bd.battu;
		$('.attyresultscol').hide();
	} else {
		if (bd.vw) {
			bd.coilpow = bd.vwset;
			bd.coilu = Math.sqrt(bd.coilpow * bd.attyres);
			bd.coilcurr = bd.coilu / bd.attyres;
		} else {
			bd.coilu = bd.vvset;
			bd.coilcurr = bd.coilu/bd.attyres;
			bd.coilpow = bd.coilu * bd.coilcurr;
		}
		html += '<tr>';
			html += '<td>Voltage</td>';
			html += '<td class="text-right">'+round(bd.coilu,2)+'</td>';
			html += '<td>V</td>';
		html += '</tr>';
		html += '<tr>';
			html += '<td>Current</td>';
			html += '<td class="text-right">'+round(bd.coilcurr,2)+'</td>';
			html += '<td>A</td>';
		html += '</tr>';
		html += '<tr>';
			html += '<td>Power</td>';
			html += '<td class="text-right">'+round(bd.coilpow,2)+'</td>';
			html += '<td>W</td>';
		html += '</tr>';
		$('.attyresultscol').show();
		$('#bd-attyresults').html(html);
		bd.battpow = bd.coilpow / bd.effic;
		bd.battcurr = bd.battpow/bd.battu;
	}
	html = '';
	html += '<tr>';
		html += '<tr>';
			html += '<td>Voltage</td>';
			html += '<td class="text-right">'+round(bd.battu,2)+'</td>';
			html += '<td>V</td>';
		html += '</tr>';
		html += '<td>Current</td>';
		html += '<td class="text-right">'+round(bd.battcurr,2)+'</td>';
		html += '<td>A</td>';
	html += '</tr>';
	html += '<tr>';
		html += '<td>Power</td>';
		html += '<td class="text-right">'+round(bd.battpow,2)+'</td>';
		html += '<td>W</td>';
	html += '</tr>';
	$('#bd-battresults').html(html);
	html = '';
	bd.amplimit = (bd.battcap/1000) * bd.crating;
	html += '<tr title="Battery capacity multiplied with C rating">';
		html += '<td>Amp limit</td>';
		html += '<td class="text-right">'+round(bd.amplimit,2)+'</td>';
		html += '<td>A</td>';
	html += '</tr>';
	bd.amplimitpercent = (bd.battcurr/bd.amplimit)*100;
	//console.log(bd.amplimitpercent);
	html += '<tr>';
		html += '<td>Amp limit headroom <small>@ '+bd.battu+' V</small></td>';
		if (bd.amplimitpercent>100) {
			html += '<td class="text-right danger" title="Overcurrent">' + round(100-bd.amplimitpercent,0) + '</td>';
		} else if (bd.amplimitpercent>90) {
			html += '<td class="text-right danger" title="Almost no headroom - You should have at least 20% headroom">' + round(100-bd.amplimitpercent,0) + '</td>';
		} else if (bd.amplimitpercent>80) {
			html += '<td class="text-right warning" title="You should have at least 20% headroom">' + round(100-bd.amplimitpercent,0) + '</td>';
		} else if (bd.amplimitpercent>70) {
			html += '<td class="text-right">' + round(100-bd.amplimitpercent,0) + '</td>';
		} else {
			html += '<td class="text-right success">' + round(100-bd.amplimitpercent,0) + '</td>';
		}
		html += '<td>%</td>';
	html += '</tr>';

	$('#bd-battlimit').html(html);
	html = '';
	bd.battcappow = (bd.battcap/1000)*bd.nomu;
	html += '<tr>';
		html += '<td>Battery power capacity <small class="text-muted">@ '+bd.nomu+' V</small></td>';
		html += '<td class="text-right">'+round(bd.battcappow,2)+'</td>';
		html += '<td title="Watt-hours">Wh</td>';
	html += '</tr>';
	
	
	
	/*
	Batteri-tid for mech: 
	Konverter mAh til Wh ved å bruke nominell spenning.
	Finn "nominell strøm" og "nominell effekt" ved å bruke motstand og nominell spenning.
	*/
	var tmpNomI, tmpNomP;
	if (bd.apv) {
		bd.battime = (bd.battcappow/bd.battpow) * 60;
	} else {
		tmpNomI = bd.nomu / bd.attyres;
		tmpNomP = bd.nomu * tmpNomI;
		tmpNomP /= bd.effic;
		html += '<tr>';
			html += '<td>"Nominal" power <small class="text-muted">'+bd.nomu+' V @ '+bd.attyres+' &ohm;</small></td>';
			html += '<td class="text-right">'+round(tmpNomP,2)+'</td>';
			html += '<td>W</td>';
		html += '</tr>';
		bd.battime = (bd.battcappow/tmpNomP) * 60;
	}

	html += '<tr title="How long your battery will last if you fire your mod continuously.">';
		html += '<td>Estimated total runtime</td>';
		html += '<td class="text-right">'+round(bd.battime,0)+'</td>';
		html += '<td>min</td>';
	html += '</tr>';

	bd.battpuffs = (bd.battime/(5/60));
	html += '<tr>';
		html += '<td>Estimated # puffs <small class="text-muted">@ 5 sec puffs</small></td>';
		html += '<td class="text-right">'+round(bd.battpuffs,0)+'</td>';
		html += '<td><i class="glyphicon glyphicon-cloud text-muted"></i></td>';
	html += '</tr>';

	$('#bd-battruntime').html(html);

	$('#bd-battlimitpanel').show();
	$('#bd-battruntimepanel').show();
	setHelpClass($('.panel'));
	return;
}
function bdReadValues() {
	var bd = choo.bd;
	bd.apv = ($('#bd-pv-apv').is(':checked'));
	bd.vw = ($('#bd-mode-vw').is(':checked'));
	bd.attyres = readNumber($('#bd-attyres').val());
	bd.vvset = readNumber($('#bd-vapeu').val());
	bd.vwset = readNumber($('#bd-vapep').val());
	bd.battu = readNumber($('#bd-battu').val());
	if (bd.apv) {
		bd.effic = parseInt($('#bd-effic').val(),10)/100;
	} else {
		bd.effic = 1;
	}
	bd.nomu = readNumber($('#bd-nomu').val());
	if (bd.attyres<0.1) {
		bd.attyres = 0.1;
		$('#bd-attyres').val(bd.attyres);
	}
	if (bd.vvset < 0.1) {
		bd.vvset = 0.1;
		$('#bd-vapeu').val(bd.vvset);
	}
	if (bd.vwset < 0.1) {
		bd.vwset = 0.1;
		$('#bd-vapep').val(bd.vwset);
	}
	if (bd.battu < 0.1) {
		bd.battu = 0.1;
		$('#bd-battu').val(bd.battu);
	}
	if (bd.effic>1) {
		bd.effic = 1;
		$('#bd-battu').val(bd.battu);
		$('#bd-effic').val(round(bd.effic*100,0));
	} else if (bd.effic<0.01) {
		bd.effic = 0.01;
		$('#bd-effic').val(round(bd.effic*100,0));
	}
	bd.battcap = readNumber($('#bd-battcap').val());
	bd.crating = readNumber($('#bd-crating').val());
	return;
}
function bdWriteValues() {
	var bd = choo.bd;
	if (bd.apv) {
		$('#bd-pv-apv').prop('checked',true);
	} else {
		$('#bd-pv-mech').prop('checked',true);
	}
	if (bd.vw) {
		$('#bd-mode-vw').prop('checked',true);
	} else {
		$('#bd-mode-vv').prop('checked',true);
	}
	$('#bd-attyres').val(bd.attyres);
	$('#bd-vapeu').val(bd.vvset);
	$('#bd-vapep').val(bd.vwset);
	$('#bd-battu').val(bd.battu);
	$('#bd-effic').val(round(bd.effic*100,0));
	$('#bd-battcap').val(bd.battcap);
	$('#bd-crating').val(round(bd.crating,2));
	$('#bd-nomu').val(bd.nomu);
	
	return;
}
function initBattDrain() {
	return {
		apv : false
		,vw : false
		,attyres : 1.8
		,vvset : 3.7
		,vwset : 7.5
		,battu : 4.2
		,effic : 0.9
		,battcap: 700
		,crating: 5
		,nomu: 3.7
	};
}

function bdLoad() {
	var bd = seLoad('bd');
	if (bd===undefined) {
		choo.bd = initBattDrain();
		$('#bd-load').hide();
	} else {
		if (bd.nomu===undefined) { bd.nomu = 3.7; }
		choo.bd = bd;
		//console.log(bd);
	}
	bdWriteValues();
	calcBattDrain();
	bdShowHide();
	return;
}

function makeBattPresetOptions() {
	var bpresets = $.parseJSON($('#battpresets').html());
	var html = '';
	var tmp;
	var ii;
	for (ii=0;ii<bpresets.length;ii++) {
		tmp = bpresets[ii];
		tmp.q = parseFloat(tmp.q);
		if (tmp.a) {
			tmp.a = parseFloat(tmp.a);
			tmp.c = (tmp.a*1000/tmp.q);
		} else {
			tmp.c = parseFloat(tmp.c);
		}
		html += '<option class="notranslate" data-battcap="'+tmp.q+'" data-crating="'+tmp.c+'" data-nm="'+tmp.nm+'" value="'+tmp.nm+','+tmp.q+','+tmp.c+'"';
		if (tmp.t!==undefined) {
			html += ' title="'+tmp.t+'"';
		}
		html += '>';
			html += tmp.nm + ' (' + tmp.q + ' mAh, ';
			if (tmp.a) {
				html += tmp.a + 'A';
				html += ' = ' + round(parseFloat(tmp.c),2) + 'C';
			} else {
				html += tmp.c + 'C';
			}
			html += ')';
		html += '</option>';
	}
	$('#bd-battpre').html('<option data-battcap=""></option>' + html); // '<option value="unknown">My battery is not in the list</option>'
	return;
}

function startBatt() {
	bdLoad();
	bdWriteValues();
	$('#bd-pv-radio input').change(function() {
		bdReadValues();
		calcBattDrain();
		bdShowHide();
		gad('batt', 'apv', bool2int(choo.bd.apv));
	});
	$('#bd-mode-radio input').change(function() {
		var bd = choo.bd;
		bdReadValues();
		bd.vwset = bd.coilpow;
		bd.vvset = bd.coilu;
		calcBattDrain();
		if (bd.vw) {
			$('#bd-vapep').val(round(bd.vwset,1));
		} else {
			$('#bd-vapeu').val(round(bd.vvset,1));
		}
		bdShowHide();
		gad('batt', 'vw', bool2int(bd.vw));
	});
	$('input.form-control').change(function() {
		bdReadValues();
		calcBattDrain();
		gad('batt', 'calc');
	});
	$('#bd-reset').click(function() {
		choo.bd = initBattDrain();
		bdWriteValues();
		calcBattDrain();
		bdShowHide();
		ccMenuMsg('Default settings have been restored.','success');
		gad('batt', 'reset');
	});
	$('#bd-save').click(function() {
		var bd = choo.bd;
		seSave('bd',bd);
		$('#bd-load').show();
		gad('batt', 'save');
	});
	$('#bd-load').click(function() {
		bdLoad();
		gad('batt', 'load');
	});
	function setBattPre() {
		var bd = choo.bd;
		var $opt = $('#bd-battpre').find(':selected');
		if ($opt.val()==='unknown') {
			feedbackModal(
				'Suggest battery preset'
				,'<p><strong>If you don\'t find your battery among the presets, you can manually enter the stats in the calculator.</strong></p><p>If you also want your battery to be listed in the presets some time in the future, you can suggest it here. Please fill out all the required specifications. <strong>Incomplete submissions will be deleted.</strong> Without all the required specs, it is not possible to calculate anything useful.</p>'
				,'I would like to see the following battery in the preset list:\nName (make/model) (REQUIRED): \nCapacity (mAh) (REQUIRED): \nC rating/amp drain (REQUIRED): \nNominal voltage (default 3.7V):'
			);
			$('.modal-body').find('textarea').css('height','10em');
			return false;
		}
		var tmpCap = $opt.attr('data-battcap');
		if (tmpCap === '') { return; }
		var tmpNom = $opt.attr('data-nomu');
		var tmpCra = $opt.attr('data-crating');
		bd.battcap = parseFloat(tmpCap);
		if (tmpNom === undefined) {
			bd.nomu = 3.7;
		} else {
			bd.nomu = parseFloat(tmpNom);
		}
		bd.crating = parseFloat(tmpCra);
		bdWriteValues();
		calcBattDrain();
		
		var disclaimer = 'Presets are for convenience only, and are not to be trusted blindly. Please verify capacity, nominal voltage and C rating.';

		if ($opt.attr('title') !== undefined) {
			ccMenuMsg('<p>Note: ' + $opt.attr('title') + '</p><p>' + disclaimer + '</p>','danger',16000);
		} else {
			ccMenuMsg('<p>Note: ' + disclaimer + '</p>','warning',8000);
		}
		
		return {
			nm: $opt.attr('data-nm')
			,mah: $opt.attr('data-battcap')
			,c: $opt.attr('data-crating')
		};
	}
	$('#bd-battpre').change(function() {
		$('.fade5').remove();
		var pre = setBattPre();
		if (pre===false) {
			return;
		}
		if (pre.nm===undefined) {
			updateQs('?');
		} else {
			updateQs('&b=' + pre.nm.replace(/ /g,'_') + '&mah=' + pre.mah + '&c=' + pre.c);
			gad('batt', 'preset', pre.nm);
		}
		return;
	});
	makeBattPresetOptions();
	var qs = getQueryStrings();
	if (Object.keys(qs).length>0) {
		var nm = qs.b.replace(/_/g, ' ');
		$('#bd-battpre').val(nm + ',' + qs.mah + ',' + qs.c);
		setBattPre();
	}
	bdShowHide();
	calcBattDrain();
	return;
}

$(document).ready(function() {
	startBatt();
});